## libpodofo 0.9.6+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

#*****************  IMPORTANT  ************* IMPORTANT **********************
# Look at http://www.vtk.org/Wiki/CMake_HowToDoPlatformChecks
# and the other wiki entries before you add anything. You might not need to.
#****************************************************************************

#
# Project name and version
#
PROJECT(PoDoFo)

SET(PODOFO_VERSION_MAJOR "0" CACHE STRING "Major part of PoDoFo version number")
SET(PODOFO_VERSION_MINOR "9" CACHE STRING "Minor part of PoDoFo version number")
SET(PODOFO_VERSION_PATCH "6" CACHE STRING "Patchlevel part of PoDoFo version number")
SET(PODOFO_SOVERSION "${PODOFO_VERSION_MAJOR}.${PODOFO_VERSION_MINOR}.${PODOFO_VERSION_PATCH}")
SET(PODOFO_LIBVERSION "${PODOFO_SOVERSION}")


#
# Main includes
#
INCLUDE(CheckIncludeFile)
INCLUDE(CheckLibraryExists)
INCLUDE(TestBigEndian)
INCLUDE(CheckTypeSize)

#
# Setup CMake Policies
#

# Prefer files in CMAKE_MODULE_PATH over shipped ones in module directory
CMAKE_POLICY(SET CMP0017 NEW) # https://cmake.org/cmake/help/v3.0/policy/CMP0017.html
# Do not use export_library_dependencies() anymore
if(POLICY CMP0033)
CMAKE_POLICY(SET CMP0033 NEW) # https://cmake.org/cmake/help/v3.0/policy/CMP0033.html
endif()

# Load modules from our source tree too
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")


# Builds must use this CMakeLists.txt, not the one in src/ or somewhere else.
# If users try to use something else the results can be confusing. We set a
# variable here that we require to be set elsewhere, otherwise we'll complain.
SET(PODOFO_MAIN_CMAKELISTS_READ TRUE)

# If the user hasn't told use specifically what they want, build only
# a static library or only a shared library on Windows.
IF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
    IF(WIN32)
        SET(PODOFO_BUILD_STATIC FALSE)
        SET(PODOFO_BUILD_SHARED TRUE)
    ELSE(WIN32)
        SET(PODOFO_BUILD_STATIC TRUE)
        SET(PODOFO_BUILD_SHARED FALSE)
    ENDIF(WIN32)
ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
IF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
    IF(PODOFO_BUILD_SHARED)
        SET(PODOFO_BUILD_STATIC FALSE)
    ELSE(PODOFO_BUILD_SHARED)
        SET(PODOFO_BUILD_STATIC TRUE)
    ENDIF(PODOFO_BUILD_SHARED)
ENDIF(DEFINED PODOFO_BUILD_SHARED AND NOT DEFINED PODOFO_BUILD_STATIC)
IF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)
    IF(PODOFO_BUILD_STATIC)
        SET(PODOFO_BUILD_SHARED FALSE)
    ELSE(PODOFO_BUILD_STATIC)
        SET(PODOFO_BUILD_SHARED TRUE)
    ENDIF(PODOFO_BUILD_STATIC)
ENDIF(NOT DEFINED PODOFO_BUILD_SHARED AND DEFINED PODOFO_BUILD_STATIC)

IF(DEFINED LIB_SUFFIX)
	SET(LIBDIRNAME "lib${LIB_SUFFIX}")
ELSE(DEFINED LIB_SUFFIX)

# Some 64 bit linux distros use /usr/lib64 for 64 bit libraries.
# on these platforms we must
IF(NOT DEFINED WANT_LIB64)
	# TODO: detect 64-bit build and existance of /usr/lib64 and set to TRUE.
	MESSAGE("WANT_LIB64 unset; assuming normal library directory names")
	SET(WANT_LIB64 FALSE)
ENDIF(NOT DEFINED WANT_LIB64)

IF(WANT_LIB64)
	SET(LIBDIRNAME "lib64")
ELSE(WANT_LIB64)
	SET(LIBDIRNAME "lib")
ENDIF(WANT_LIB64)

ENDIF(DEFINED LIB_SUFFIX)
MESSAGE("Will install libraries to ${CMAKE_INSTALL_PREFIX}/${LIBDIRNAME}")

# Some headers that tend to vary a bit
CHECK_INCLUDE_FILE("strings.h" PODOFO_HAVE_STRINGS_H) 
CHECK_INCLUDE_FILE("arpa/inet.h" PODOFO_HAVE_ARPA_INET_H) 
CHECK_INCLUDE_FILE("winsock2.h" PODOFO_HAVE_WINSOCK2_H) 
CHECK_INCLUDE_FILE("mem.h" PODOFO_HAVE_MEM_H) 
CHECK_INCLUDE_FILE("ctype.h" PODOFO_HAVE_CTYPE_H) 

# Do some type size detection and provide yet another set of typedefs for fixed
# font sizes. We can't use the c99 / c++0x uint32_t etc, because people use
# ancient compilers that don't and will never support the standard.

CHECK_INCLUDE_FILE("sys/types.h" PODOFO_HAVE_SYS_TYPES_H) 
CHECK_INCLUDE_FILE("stdint.h" PODOFO_HAVE_STDINT_H) 
# See: http://msdn.microsoft.com/en-us/library/aa384264(VS.85).aspx
CHECK_INCLUDE_FILE("BaseTsd.h" PODOFO_HAVE_BASETSD_H) 

CHECK_TYPE_SIZE("long int" SZ_LONG)

# We cache integer type detection results, and don't repeat them
# (and overwrite the user's manual changes) if they've been done already.
IF(NOT PDF_INT64_TYPENAME)
  # I hate old compilers.
  IF(PODOFO_HAVE_STDINT_H)
    SET(pdfint8 "int8_t")
    SET(pdfint16 "int16_t")
    SET(pdfint32 "int32_t")
    SET(pdfint64 "int64_t")
    SET(pdfuint8 "uint8_t")
    SET(pdfuint16 "uint16_t")
    SET(pdfuint32 "uint32_t")
    SET(pdfuint64 "uint64_t")
    CHECK_TYPE_SIZE("int64_t" SZ_INT64)
  ELSE(PODOFO_HAVE_STDINT_H)
    # No stdint.h . Try BaseTsd.h windows types.
    IF(PODOFO_HAVE_BASETSD_H)
       # We have BaseTsd.h, so use those types.
       SET(pdfint8  "signed char")
       SET(pdfint16 "short")
       SET(pdfint32 "INT32")
       SET(pdfint64 "INT64")
       SET(pdfuint8 "unsigned char")
       SET(pdfuint16 "unsigned short")
       SET(pdfuint32 "UINT32")
       SET(pdfuint64 "UINT64")
       CHECK_TYPE_SIZE("INT64" SZ_INT64)
    ELSE(PODOFO_HAVE_BASETSD_H)
       # No BaseTsd.h either. Assume the standard types, and go poking
       # for a sane 64-bit integer.
       #
       # First, though, make sure sizeof(int) = 4 and if not, scream, because
       # hopefully this case will never be hit and we'll never have to write
       # the horrible code check for
       CHECK_TYPE_SIZE("signed char"        SZ_TINY_INT)
       CHECK_TYPE_SIZE("unsigned char"      SZ_TINY_UINT)
       CHECK_TYPE_SIZE("short int"          SZ_SHORT_INT)
       CHECK_TYPE_SIZE("int"                SZ_INT)
       CHECK_TYPE_SIZE("unsigned short int" SZ_UINT)
       CHECK_TYPE_SIZE("unsigned int"       SZ_SHORT_UINT)
       SET(smallintsok SZ_INT == 4 AND SZ_UINT == 4 AND SZ_SHORT_INT == 2 AND SZ_SHORT_UINT == 2 AND SZ_TINY_INT == 1 AND SZ_TINY_UINT == 1)
       IF(NOT smallintsok)
         MESSAGE(FATAL "sizeof(int) != 4 and/or sizeof(short) != 2 and no stdint.h or BaseTsd.h found. We don't know how to cope with this.")
       ENDIF(NOT smallintsok)
       SET(pdfint8 "signed char")
       SET(pdfint16 "short")
       SET(pdfint32 "int")
       SET(pdfuint8 "unsigned char")
       SET(pdfuint16 "unsigned short")
       SET(pdfuint32 "unsigned int")
       # Now we just have to figure out what 64-bit integer type we can use.
       #
       # Do we have VC >= 6's __uint64 and __int64?
       # See: http://icfun.blogspot.com/2008/04/use-of-int64-variable-in-c.html
       CHECK_TYPE_SIZE("__int64" SZ___INT64)
       CHECK_TYPE_SIZE("__uint64"  SZ___UINT64)
       IF(SZ___INT64 == 8 AND SZ___UINT64 == 8)
         # MS compiler, VC6 or newer without BaseTsd.h in SDK
         SET(pdfint64 "__int64")
         SET(pdfuint64 "__uint64")
	 CHECK_TYPE_SIZE("__int64" SZ_INT64)
       ELSE(SZ___INT64 AND SZ___UINT64)
         # Still no luck. Old unix compiler, Borland, or some other monster?
         # Are we lucky and sizeof(long) == 8?
         CHECK_TYPE_SIZE("unsigned long int" SZ_ULONG)
         IF(SZ_LONG == 8 AND SZ_ULONG == 8)
           # Must be on a LP64 platform, sizeof(long) = 8
           SET(pdfint64 "long int")
           SET(pdfuint64 "unsigned long int")
	   CHECK_TYPE_SIZE("long int" SZ_INT64)
         ELSE(SZ_LONG == 8 AND SZ_ULONG == 8)
           # See if the compiler implements "long long int", int64_t, int64,
           # or _int64 (in this order, __int64 check already done)
           IF(PODOFO_HAVE_SYS_TYPES_H)
             SET(CMAKE_EXTRA_INCLUDE_FILES "sys/types.h")
           ENDIF(PODOFO_HAVE_SYS_TYPES_H)
           CHECK_TYPE_SIZE("long long int"          SZ_LONG_LONG)
           CHECK_TYPE_SIZE("unsigned long long int" SZ_UNSIGNED_LONG_LONG)
           IF(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
             SET(pdfint64 "long long int")
             SET(pdfuint64 "unsigned long long int")
             CHECK_TYPE_SIZE("long long int" SZ_INT64)
           ELSE(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
             # The standard type int64_t is normally found in stdint.h,
             # but use a type of this name anyway if present
             CHECK_TYPE_SIZE("int64_t"       SZ_INT64_T)
             CHECK_TYPE_SIZE("uint64_t"      SZ_UINT64_T)
             IF(SZ_INT64_T AND SZ_UINT64_T)
               SET(pdfint64 "int64_t")
               SET(pdfuint64 "uint64_t")
	       CHECK_TYPE_SIZE("int64_t" SZ_INT64)
             ELSE(SZ_INT64_T AND SZ_UINT64_T)
               CHECK_TYPE_SIZE("int64"                SZ_INT64)
               CHECK_TYPE_SIZE("uint64"               SZ_UINT64)
               IF(SZ_INT64 AND SZ_UINT64)
                 SET(pdfint64 "int64")
                 SET(pdfuint64 "uint64")
		 CHECK_TYPE_SIZE("int64" SZ_INT64)
               ELSE(SZ_INT64 AND SZ_UINT64)
                 CHECK_TYPE_SIZE("_int64"                SZ__INT64)
                 CHECK_TYPE_SIZE("_uint64"               SZ__UINT64)
                 IF(SZ__INT64 AND SZ__UINT64)
                   SET(pdfint64 "_int64")
                   SET(pdfuint64 "_uint64")
		   CHECK_TYPE_SIZE("_int64" SZ_INT64)
                 ELSE(SZ__INT64 AND SZ__UINT64)
                   MESSAGE("Oh my lord, your compiler doesn't seem to support any of the int64 type flavours we tried.")
                   MESSAGE(WARNING "You must set the PDF_INTxx_TYPENAME and PDF_UINTxx_TYPENAME variables manually")
                 ENDIF(SZ__INT64 AND SZ__UINT64)
               ENDIF(SZ_INT64 AND SZ_UINT64)
             ENDIF(SZ_INT64_T AND SZ_UINT64_T)
           ENDIF(SZ_LONG_LONG == 8 AND SZ_UNSIGNED_LONG_LONG == 8)
         ENDIF(SZ_LONG == 8 AND SZ_ULONG == 8)
       ENDIF(SZ___INT64 AND SZ___UINT64)
    ENDIF(PODOFO_HAVE_BASETSD_H)
  ENDIF(PODOFO_HAVE_STDINT_H)
  SET(CMAKE_EXTRA_INCLUDE_FILES)
ENDIF(NOT PDF_INT64_TYPENAME)

IF(NOT PDF_INT64_TYPENAME AND pdfint64)
  SET(PDF_INT64_TYPENAME  "${pdfint64}" CACHE STRING "Name of detected 64-bit signed integer type to use")
  SET(PDF_INT32_TYPENAME  "${pdfint32}" CACHE STRING "Name of detected 32-bit signed integer type to use")
  SET(PDF_INT16_TYPENAME  "${pdfint16}" CACHE STRING "Name of detected 16-bit signed integer type to use")
  SET(PDF_INT8_TYPENAME   "${pdfint8}" CACHE STRING "Name of detected 8-bit signed integer type to use")
  SET(PDF_UINT64_TYPENAME "${pdfuint64}" CACHE STRING "Name of detected 64-bit unsigned integer type to use")
  SET(PDF_UINT32_TYPENAME "${pdfuint32}" CACHE STRING "Name of detected 32-bit unsigned integer type to use")
  SET(PDF_UINT16_TYPENAME "${pdfuint16}" CACHE STRING "Name of detected 16-bit unsigned integer type to use")
  SET(PDF_UINT8_TYPENAME  "${pdfuint8}" CACHE STRING "Name of detected 8-bit unsigned integer type to use")
ENDIF(NOT PDF_INT64_TYPENAME AND pdfint64)

# Linux packagers want an uninstall target.
CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall "${CMAKE_COMMAND}"
    -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# Check if we are big endian
TEST_BIG_ENDIAN(TEST_BIG)

IF(WIN32)
    # We must explicitly link to the core win32 libraries, and we need winsock2
    # to get some byte-order conversion routines too.
    SET(PLATFORM_SYSTEM_LIBRARIES kernel32 user32 gdi32 winspool comdlg32 advapi32 shell32 ole32 oleaut32 uuid ws2_32)
    # Microsoft deprecate certain POSIX functions that we use.
    # for now, turn off these warnings.
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    # We need a fake unistd.h for some libraries to build. They try to include <unistd.h>
    # which is not available under win32 with MSVC++, but everything in unistd.h is defined,
    # so an empty file solves the issue.
    SET(EXTRA_INCLUDES ${PoDoFo_SOURCE_DIR}/vcincludes)
ELSE(WIN32)
    SET(PLATFORM_SYSTEM_LIBRARIES)
    SET(EXTRA_INCLUDES)
ENDIF(WIN32)

IF(UNIX AND NOT PODOFO_NO_FONTMANAGER)
    SET(WANT_FONTCONFIG TRUE CACHE INTERNAL

=== src/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

IF(NOT PODOFO_MAIN_CMAKELISTS_READ)
  MESSAGE(FATAL_ERROR "Run cmake on the CMakeLists.txt in the project root, not the one in the 'src' directory. You will need to delete CMakeCache.txt from the current directory.")
ENDIF(NOT PODOFO_MAIN_CMAKELISTS_READ)

SET(PODOFO_BASE_DEPEND_TARGET CACHE INTERNAL
    "Which PoDoFo library target to depend on when building tools and tests")
SET(PODOFO_DEPEND_TARGET CACHE INTERNAL
    "Which PoDoFo library target to depend on when building tools and tests")

SET(PODOFO_BASE_SOURCES
  base/PdfArray.cpp
  base/PdfCanvas.cpp
  base/PdfColor.cpp
  base/PdfContentsTokenizer.cpp
  base/PdfData.cpp
  base/PdfDataType.cpp
  base/PdfDate.cpp
  base/PdfDictionary.cpp
  base/PdfEncoding.cpp
  base/PdfEncodingFactory.cpp
  base/PdfEncrypt.cpp
  base/PdfError.cpp
  base/PdfFileStream.cpp
  base/PdfFilter.cpp
  base/PdfFiltersPrivate.cpp
  base/PdfImmediateWriter.cpp
  base/PdfInputDevice.cpp
  base/PdfInputStream.cpp
  base/PdfLocale.cpp
  base/PdfMemStream.cpp
  base/PdfMemoryManagement.cpp
  base/PdfName.cpp
  base/PdfObject.cpp
  base/PdfObjectStreamParserObject.cpp
  base/PdfOutputDevice.cpp
  base/PdfOutputStream.cpp
  base/PdfParser.cpp
  base/PdfParserObject.cpp
  base/PdfRect.cpp
  base/PdfRefCountedBuffer.cpp
  base/PdfRefCountedInputDevice.cpp
  base/PdfReference.cpp
  base/PdfStream.cpp
  base/PdfString.cpp
  base/PdfTokenizer.cpp
  base/PdfVariant.cpp
  base/PdfVecObjects.cpp
  base/PdfWriter.cpp
  base/PdfXRef.cpp
  base/PdfXRefStream.cpp
  base/PdfXRefStreamParserObject.cpp
  )

SET(PODOFO_DOC_SOURCES
  doc/PdfAcroForm.cpp
  doc/PdfAction.cpp
  doc/PdfAnnotation.cpp
  doc/PdfCMapEncoding.cpp
  doc/PdfContents.cpp
  doc/PdfDestination.cpp
  doc/PdfDifferenceEncoding.cpp
  doc/PdfDocument.cpp
  doc/PdfElement.cpp
  doc/PdfEncodingObjectFactory.cpp
  doc/PdfExtGState.cpp
  doc/PdfField.cpp
  doc/PdfFileSpec.cpp
  doc/PdfFont.cpp
  doc/PdfFontCID.cpp
  doc/PdfFontCache.cpp
  doc/PdfFontConfigWrapper.cpp
  doc/PdfFontFactory.cpp
  doc/PdfFontMetrics.cpp
  doc/PdfFontMetricsBase14.cpp
  doc/PdfFontMetricsFreetype.cpp
  doc/PdfFontMetricsObject.cpp
  doc/PdfFontSimple.cpp
  doc/PdfFontTTFSubset.cpp
  doc/PdfFontTrueType.cpp
  doc/PdfFontType1.cpp
  doc/PdfFontType3.cpp
  doc/PdfFontType1Base14.cpp
  doc/PdfFunction.cpp
  doc/PdfHintStream.cpp
  doc/PdfIdentityEncoding.cpp
  doc/PdfImage.cpp
  doc/PdfInfo.cpp
  doc/PdfMemDocument.cpp
  doc/PdfNamesTree.cpp
  doc/PdfOutlines.cpp
  doc/PdfPage.cpp
  doc/PdfPagesTree.cpp
  doc/PdfPagesTreeCache.cpp
  doc/PdfPainter.cpp
  doc/PdfPainterMM.cpp
  doc/PdfShadingPattern.cpp
  doc/PdfSignOutputDevice.cpp
  doc/PdfSignatureField.cpp
  doc/PdfStreamedDocument.cpp
  doc/PdfTable.cpp
  doc/PdfTilingPattern.cpp
  doc/PdfXObject.cpp
  )

IF(WIN32)
    # If we build for windows systems, we also include the resource file
    SET(PODOFO_DOC_SOURCES ${PODOFO_DOC_SOURCES} doc/podofo-doc.rc)
ENDIF(WIN32)

SET(PODOFO_HEADERS
  podofo-base.h
  podofo.h)

SET(PODOFO_BASE_HEADERS
   ${PoDoFo_BINARY_DIR}/podofo_config.h
   base/Pdf3rdPtyForwardDecl.h
   base/PdfArray.h
   base/PdfCanvas.h
   base/PdfColor.h
   base/PdfCompilerCompat.h
   base/PdfCompilerCompatPrivate.h
   base/PdfContentsTokenizer.h
   base/PdfData.h
   base/PdfDataType.h
   base/PdfDate.h
   base/PdfDefines.h
   base/PdfDefinesPrivate.h
   base/PdfDictionary.h
   base/PdfEncoding.h
   base/PdfEncodingFactory.h
   base/PdfEncrypt.h
   base/PdfExtension.h
   base/PdfError.h
   base/PdfFileStream.h
   base/PdfFilter.h
   base/PdfFiltersPrivate.h
   base/PdfImmediateWriter.h
   base/PdfInputDevice.h
   base/PdfInputStream.h
   base/PdfLocale.h
   base/PdfMemStream.h
   base/PdfMemoryManagement.h
   base/PdfName.h
   base/PdfObject.h
   base/PdfObjectStreamParserObject.h
   base/PdfOutputDevice.h
   base/PdfOutputStream.h
   base/PdfParser.h
   base/PdfParserObject.h
   base/PdfRect.h
   base/PdfRefCountedBuffer.h
   base/PdfRefCountedInputDevice.h
   base/PdfReference.h
   base/PdfStream.h
   base/PdfString.h
   base/PdfTokenizer.h
   base/PdfVariant.h
   base/PdfVecObjects.h
   base/PdfVersion.h
   base/PdfWriter.h
   base/PdfXRef.h
   base/PdfXRefStream.h
   base/PdfXRefStreamParserObject.h
   base/podofoapi.h
   )

SET(PODOFO_BASE_HEADERS2 
    base/util/PdfMutex.h
    base/util/PdfMutexImpl_noop.h
    base/util/PdfMutexImpl_win32.h
    base/util/PdfMutexImpl_pthread.h
    base/util/PdfMutexWrapper.h
    )

SET(PODOFO_DOC_HEADERS
  doc/PdfAcroForm.h
  doc/PdfAction.h
  doc/PdfAnnotation.h
  doc/PdfCMapEncoding.h
  doc/PdfContents.h
  doc/PdfDestination.h
  doc/PdfDifferenceEncoding.h
  doc/PdfDocument.h
  doc/PdfElement.h
  doc/PdfEncodingObjectFactory.h
  doc/PdfExtGState.h
  doc/PdfField.h
  doc/PdfFileSpec.h
  doc/PdfFont.h
  doc/PdfFontCID.h
  doc/PdfFontCache.h
  doc/PdfFontConfigWrapper.h
  doc/PdfFontFactory.h
  doc/PdfFontFactoryBase14Data.h
  doc/PdfFontMetrics.h
  doc/PdfFontMetricsBase14.h
  doc/PdfFontMetricsFreetype.h
  doc/PdfFontMetricsObject.h
  doc/PdfFontSimple.h
  doc/PdfFontTTFSubset.h
  doc/PdfFontTrueType.h
  doc/PdfFontType1.h
  doc/PdfFontType3.h
  doc/PdfFontType1Base14.h
  doc/PdfFunction.h
  doc/PdfHintStream.h
  doc/PdfIdentityEncoding.h
  doc/PdfImage.h
  doc/PdfInfo.h
  doc/PdfMemDocument.h
  doc/PdfNamesTree.h
  doc/PdfOutlines.h
  doc/PdfPage.h
  doc/PdfPagesTree.h
  doc/PdfPagesTreeCache.h
  doc/PdfPainter.h
  doc/PdfPainterMM.h
  doc/PdfShadingPattern.h
  doc/PdfSignOutputDevice.h
  doc/PdfSignatureField.h
  doc/PdfStreamedDocument.h
  doc/PdfTable.h
  doc/PdfTilingPattern.h
  doc/PdfXObject.h
  )

SET(PODOFO_HEADER_FILES
  ${PODOFO_HEADERS}
  ${PODOFO_BASE_HEADERS}
  ${PODOFO_BASE_HEADERS2}
  ${PODOFO_DOC_HEADERS}
  )

# Create a Source Group for Visual Studio
# so that headers are listed in the folder view
# and are easier accessible
SOURCE_GROUP("Header Files" FILES ${PODOFO_HEADER_FILES})

INSTALL(FILES ${PODOFO_HEADERS}
  DESTINATION "include/podofo"
  )

INSTALL(FILES ${PODOFO_BASE_HEADERS}
    DESTINATION "include/podofo/base"
    )

INSTALL(FILES ${PODOFO_BASE_HEADERS2}
    DESTINATION "include/podofo/base/util"
    )

INSTALL(FILES ${PODOFO_DOC_HEADERS}
    DESTINATION "include/podofo/doc"
    )

IF(NOT PODOFO_BUILD_SHARED AND NOT PODOFO_BUILD_STATIC)
    MESSAGE(FATAL_ERROR "At least one of PODOFO_BUILD_SHARED and PODOF_BUILD_STATIC must be set")
ENDIF(NOT PODOFO_BUILD_SHARED AND NOT PODOFO_BUILD_STATIC)

IF(PODOFO_BUILD_STATIC)
    MESSAGE("Building static PoDoFo library")
    ADD_LIBRARY(podofo_static STATIC ${PODOFO_BASE_SOURCES} ${PODOFO_DOC_SOURCES} ${PODOFO_HEADER_FILES})
    TARGET_LINK_LIBRARIES(podofo_static ${PODOFO_LIB_DEPENDS})
    SET_TARGET_PROPERTIES(podofo_static PROPERTIES
        VERSION "${PODOFO_LIBVERSION}"
        SOVERSION "${PODOFO_SOVERSION}"
        CLEAN_DIRECT_OUTPUT 1
        OUTPUT_NAME "podofo"
        COMPILE_FLAGS "-DBUILDING_PODOFO"
        )
    SET(PODOFO_DEPEND_TARGET podofo_static
        CACHE INTERNAL "Which PoDoFo library variant to depend on")
    SET(USING_SHARED_PODOFO FALSE)
    INSTALL(TARGETS podofo_static
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "${LIBDIRNAME}"
        ARCHIVE DESTINATION "${LIBDIRNAME}"
        )
ENDIF(PODOFO_BUILD_STATIC)

IF(PODOFO_BUILD_SHARED)
    MESSAGE("Building shared PoDoFo library")
    ADD_LIBRARY(podofo_shared SHARED ${PODOFO_BASE_SOURCES} ${PODOFO_DOC_SOURCES} ${PODOFO_HEADER_FILES})
    TARGET_LINK_LIBRARIES(podofo_shared ${PODOFO_LIB_DEPENDS})
    # TODO: set /wd4251 flag if we're doing a debug build with
    # Visual Studio, since it produces invalid warnings about STL
    # use.
    SET_TARGET_PROPERTIES(podofo_shared PROPERTIES
        VERSION "${PODOFO_LIBVERSION}"
        SOVERSION "${PODOFO_SOVERSION}"
        CLEAN_DIRECT_OUTPUT 1
        OUTPUT_NAME "podofo"
        COMPILE_FLAGS "-DBUILDING_PODOFO"
        )
    # Since we're building a shared podofo, prefer to depend on this one for
    # tests and tools over the static library (if built).
    SET(PODOFO_DEPEND_TARGET podofo_shared
        CACHE INTERNAL "Which PoDoFo library variant to depend on")
    SET(USING_SHARED_PODOFO TRUE)
    INSTALL(TARGETS podofo_shared
        RUNTIME DESTINATION "bin"
        LIBRARY DESTINATION "${LIBDIRNAME}"
        ARCHIVE DESTINATION "${LIBDIRNAME}"
        )


      # Create a pkg-config file for linking against shared library
      # if pkg-config is available on the system.
      # Add a version to the file name corresponding to the API compatibility.

      FIND_PROGRAM(PKG_CONFIG_FOUND pkg-config)
      IF(PKG_CONFIG_FOUND)
        MESSAGE("Pkg-config found, creating a pkg-config file for linking against shared library.")
        CONFIGURE_FILE(
          "libpodofo.pc.in"
          "${PoDoFo_BINARY_DIR}/libpodofo-${PODOFO_VERSION_MAJOR}.pc"
          @ONLY)
        INSTALL(
          FILES "${PoDoFo_BINARY_DIR}/libpodofo-${PODOFO_VERSION_MAJOR}.pc"
          DESTINATION "${LIBDIRNAME}/pkgconfig")
      ELSE(PKG_CONFIG_FOUND)
        MESSAGE("Pkg-config not found. No pkg-config file will be created.")
      ENDIF(PKG_CONFIG_FOUND)
ENDIF(PODOFO_BUILD_SHARED)

# Use these flags when compiling code that includes PoDoFo headers.
# Failure to do so will result in compilation or link-time errors
# on some platforms, and can even cause undefined results at runtime.
IF(WIN32 AND USING_SHARED_PODOFO)
    SET(PODOFO_CFLAGS "-DUSING_SHARED_PODOFO" CACHE INTERNAL "Extra flags required when linking to PoDoFo")
ELSE(WIN32 AND USING_SHARED_PODOFO)
    SET(PODOFO_CFLAGS "" CACHE INTERNAL "Extra flags required when linking to PoDoFo")
ENDIF(WIN32 AND USING_SHARED_PODOFO)

# Write the cflags and depend target to the config file
FILE(APPEND 
     "${PoDoFo_BINARY_DIR}/PoDoFoConfig.cmake"
     "SET(PODOFO_CFLAGS ${PODOFO_CFLAGS})\n"
     )
FILE(APPEND
     "${PoDoFo_BINARY_DIR}/PoDoFoConfig.cmake"
     "SET(PODOFO_DEPEND_TARGET ${PODOFO_DEPEND_TARGET})\n"
     )

=== test/CMakeLists.txt ===
SUBDIRS(
	ContentParser
	CreationTest
	FilterTest
	FormTest
	LargeTest
	ObjectParserTest
	ParserTest
	SignatureTest
	TokenizerTest
	VariantTest
	WatermarkTest
	unit
	)

=== tools/CMakeLists.txt ===
SUBDIRS(
	podofobox
	podofocolor
        podofocountpages
        podofocrop
	podofoencrypt
	podofogc
	podofoimgextract
	podofoimg2pdf
	podofomerge
	podofopages
	podofopdfinfo
	podofotxt2pdf
	podofotxtextract
	podofouncompress
	podofoimpose
	podofoincrementalupdates
	podofoxmp
	)

IF(PODOFO_HAVE_OPENSSL)
	SUBDIRS(podofosign)
ENDIF(PODOFO_HAVE_OPENSSL)

=== examples/helloworld-base14/CMakeLists.txt ===
# This is not a full standalone CMake configuration for the hello world
# example.
#
# To build it outside the PoDoFo source tree, you must set your build system
# make the PoDoFo headers available and must link to the PoDoFo library
# and any libraries it depends on (see the README,
#     "5. Using PoDoFo in Your Application") .
#
# Note that you don't need the headers for PoDoFo's dependencies in your
# header search path.

ADD_EXECUTABLE(helloworld-base14 helloworld-base14.cpp)

TARGET_LINK_LIBRARIES(helloworld-base14 ${PODOFO_LIB})
SET_TARGET_PROPERTIES(helloworld-base14 PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(helloworld-base14 ${PODOFO_DEPEND_TARGET})
INCLUDE_DIRECTORIES(${PoDoFo_SOURCE_DIR})

=== examples/pdfcontentsgraph/CMakeLists.txt ===
ADD_EXECUTABLE(pdfcontentsgraph PdfContentsGraph.cpp main.cpp)

TARGET_LINK_LIBRARIES(pdfcontentsgraph ${PODOFO_LIB})
SET_TARGET_PROPERTIES(pdfcontentsgraph PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(pdfcontentsgraph ${PODOFO_DEPEND_TARGET})
INCLUDE_DIRECTORIES(${PoDoFo_SOURCE_DIR})

=== test/TokenizerTest/CMakeLists.txt ===
ADD_EXECUTABLE(TokenizerTest TokenizerTest.cpp)
TARGET_LINK_LIBRARIES(TokenizerTest ${PODOFO_LIB} ${PODOFO_LIB_DEPENDS})
SET_TARGET_PROPERTIES(TokenizerTest PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(TokenizerTest ${PODOFO_DEPEND_TARGET})

# Copy the test samples over to the build tree
ADD_CUSTOM_COMMAND(
    TARGET TokenizerTest
    POST_BUILD
    COMMAND "${CMAKE_COMMAND}" -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/objects" "${CMAKE_CURRENT_BINARY_DIR}/objects"
    )

=== test/unit/CMakeLists.txt ===

IF(PODOFO_HAVE_CPPUNIT)
  INCLUDE_DIRECTORIES( ${PROJ_SOURCE_DIR}/src ${PROJ_BINARY_DIR}/src ${PROJ_BINARY_DIR}/src/os ${PROJ_BINARY_DIR}/src/os/${OROCOS_TARGET})
  ADD_DEFINITIONS("-g")
  
  # repeat for each test
  ADD_EXECUTABLE( podofo-test main.cpp ColorTest.cpp DeviceTest.cpp ElementTest.cpp EncodingTest.cpp EncryptTest.cpp 
		  FilterTest.cpp FontTest.cpp NameTest.cpp PagesTreeTest.cpp PageTest.cpp PainterTest.cpp ParserTest.cpp
                  TokenizerTest.cpp StringTest.cpp VariantTest.cpp BasicTypeTest.cpp TestUtils.cpp DateTest.cpp )
  ADD_DEPENDENCIES( podofo-test ${PODOFO_DEPEND_TARGET})
  TARGET_LINK_LIBRARIES( podofo-test ${PODOFO_LIB} ${PODOFO_LIB_DEPENDS} ${CPPUNIT_LIBRARIES} )
  SET_TARGET_PROPERTIES( podofo-test PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
  ADD_TEST( podofo-test podofo-test )
ENDIF(PODOFO_HAVE_CPPUNIT)

=== tools/podofocountpages/CMakeLists.txt ===
ADD_EXECUTABLE(podofocountpages countpages.cpp)

TARGET_LINK_LIBRARIES(podofocountpages ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofocountpages PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofocountpages ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofocountpages
	RUNTIME DESTINATION "bin")

=== tools/podofocrop/CMakeLists.txt ===
ADD_EXECUTABLE(podofocrop podofocrop.cpp)

TARGET_LINK_LIBRARIES(podofocrop ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofocrop PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofocrop ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofocrop
	RUNTIME DESTINATION "bin")

=== tools/podofoimgextract/CMakeLists.txt ===
ADD_EXECUTABLE(podofoimgextract ImageExtractor.cpp podofoimgextract.cpp)
TARGET_LINK_LIBRARIES(podofoimgextract ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofoimgextract PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofoimgextract ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofoimgextract
	RUNTIME DESTINATION "bin")

=== tools/podofotxtextract/CMakeLists.txt ===
ADD_EXECUTABLE(podofotxtextract TextExtractor.cpp podofotxtextract.cpp)

TARGET_LINK_LIBRARIES(podofotxtextract ${PODOFO_LIB})
SET_TARGET_PROPERTIES(podofotxtextract PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(podofotxtextract ${PODOFO_DEPEND_TARGET})
INSTALL(TARGETS podofotxtextract
	RUNTIME DESTINATION "bin")

=== debian/changelog ===
libpodofo (0.9.6+dfsg-5build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:18:19 +0100

libpodofo (0.9.6+dfsg-5) unstable; urgency=medium

  * Add upstream patches for security issues:
    CVE-2019-9199 Closes: #923469
    CVE-2019-9687 Closes: #924430

 -- Mattia Rizzolo <mattia@debian.org>  Sun, 21 Apr 2019 17:13:10 +0200

libpodofo (0.9.6+dfsg-4) unstable; urgency=medium

  * Add upstream patches for security issues:
    + CVE-2018-5783;  Closes: #916142
    + CVE-2018-11254; Closes: #916585
    + CVE-2018-11256; Closes: #916583
    + CVE-2018-12982; Closes: #916581
    + CVE-2018-14320; Closes: #916240
    + CVE-2018-19532; Closes: #916085
    + CVE-2018-20751
  * d/control:
    + Bump Standards-Version to 4.3.0, no changes needed.
    + Bump debhelper compat level to 12.
  * d/copyright:
    + Add a Comment field to explain the +dfsg repack, appeasing lintian.
    + Bump the year for debian/*.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 11 Feb 2019 18:49:43 +0100

libpodofo (0.9.6+dfsg-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/watch: Use https protocol.

  [ Mattia Rizzolo ]
  * Upload to unstable.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 02 Oct 2018 16:58:57 +0200

libpodofo (0.9.6+dfsg-2) experimental; urgency=medium

  * Add patch to fix FTBFS on !linux.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 22 Sep 2018 13:25:17 +0200

libpodofo (0.9.6+dfsg-1) experimental; urgency=medium

  * New upstream version 0.9.6+dfsg:
    + CVE-2017-8053 Closes: #860994
    + CVE-2018-5296
  * d/control:
    + Bump Standards-Version to 4.2.1, no changes needed.
    + Use the new notation debian-compat(=11), and drop d/compat.
  * d/patches:
    + Drop all patches, applied upstream.
    + Add patch from Juhani Numminen <juhaninumminen0@gmail.com> to fix FTBFS
      with cmake 3.12.  Closes: #906781
    + Add patch to fix the build with -fvisibility=hidden.

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 18 Sep 2018 15:53:46 +0200

libpodofo (0.9.6~rc1+dfsg-1) experimental; urgency=medium

  * New upstream version 0.9.6~rc1:
    + Repacked to remove a non-free piece of code (see README.source).
    + Fix CVE-2018-5309
    + Fix CVE-2018-8001 Closes: #892556
  * d/patches:
    + Remove all patches applied upstream.
    + Add patch to set the SOVERSION to 0.9.6 instead of 0.9.6-rc1.
    + Add a patch fixing a bunch of spelling errors.
    + Add patch from upstream to fix build on 32 bit archs.
  * Drop our manpages, now that upstream have moved all (but one) of them out
    of debian/, so we can install their copies.
  * Rename the binaries after SONAME bump: libpodofo0.9.5 → libpodofo0.9.6.
  * d/control:
    + Bump Standards-Version to 4.1.4, no changes needed.
    + Add new Build-Dependency on libunistring-dev.
  * d/rules: explicitly enable symbols visibility.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 10 May 2018 10:49:49 +0200

libpodofo (0.9.5-11) unstable; urgency=medium

  * Add patch to fix pkg-config file.
    This will also rename the file to make more sense, but as it's currently
    completely broken it doesn't really matter.  Closes: #908134; LP: #1792407

 -- Mattia Rizzolo <mattia@debian.org>  Tue, 18 Sep 2018 15:40:47 +0200

libpodofo (0.9.5-10) unstable; urgency=medium

  * Retroactively update CVEs information.  Thanks to Matthew Brincke
  * Add patch from Juhani Numminen <juhaninumminen0@gmail.com> to fix
    FTBFS with cmake 3.12.  Closes: #906781

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 27 Aug 2018 16:53:29 +0200

=== debian/control ===
Source: libpodofo
Priority: optional
Section: libdevel
Maintainer: Mattia Rizzolo <mattia@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libboost-dev,
 libcppunit-dev,
 libfontconfig1-dev,
 libfreetype6-dev (>= 2.5),
 libidn11-dev,
 libjpeg-dev,
 liblua5.1-0-dev,
 libssl-dev,
 libtiff-dev,
 libunistring-dev,
 zlib1g-dev,
Standards-Version: 4.3.0
Rules-Requires-Root: no
Homepage: http://podofo.sourceforge.net
Vcs-Git: https://salsa.debian.org/debian/libpodofo.git
Vcs-Browser: https://salsa.debian.org/debian/libpodofo

Package: libpodofo-dev
Architecture: any
Depends:
 libboost-dev,
 libpodofo0.9.6 (= ${binary:Version}),
 libssl-dev,
 ${misc:Depends},
Description: PoDoFo development files
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.
 .
 This package contains the header development files used for building
 PoDoFo-enabled applications.

Package: libpodofo-utils
Architecture: any
Section: utils
Depends:
 libpodofo0.9.6 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: PoDoFo utilities
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.
 .
 This package contains tools for working with PDF files.

Package: libpodofo0.9.6
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: PoDoFo - library to work with the PDF file format
 The PoDoFo library is a free, portable C++ library which includes classes to
 parse PDF files and modify their contents into memory. The changes can be
 written back to disk easily. The parser can also be used to extract
 information from a PDF file (for example the parser could be used in a PDF
 viewer). Besides parsing PoDoFo includes also very simple classes to create
 your own PDF files. All classes are documented so it is easy to start writing
 your own application using PoDoFo.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DWANT_FONTCONFIG:BOOL=TRUE \
	    -DWANT_BOOST:BOOL=1 \
	    -DPODOFO_BUILD_SHARED:BOOL=TRUE \
	    -DPODOFO_BUILD_STATIC:BOOL=FALSE \
	    -DPODOFO_USE_VISIBILITY:BOOL=TRUE \

override_dh_missing:
	dh_missing --fail-missing

override_dh_compress:
	dh_compress -X .pdf -X .plan

## libpodofo 0.9.7%2Bdfsg

=== test/SignTest/CMakeLists.txt ===
ADD_EXECUTABLE(SignTest SignTest.cpp)
TARGET_LINK_LIBRARIES(SignTest ${PODOFO_LIB} ${PODOFO_LIB_DEPENDS})
SET_TARGET_PROPERTIES(SignTest PROPERTIES COMPILE_FLAGS "${PODOFO_CFLAGS}")
ADD_DEPENDENCIES(SignTest ${PODOFO_DEPEND_TARGET})
